<?php defined('SYSPATH') or die('No direct script access.');
 
class Controller_Handler extends Controller {
    /** @var  Validation */
    protected  $post;

    /** @var  Validation */
    protected $get;

    /** @var  User */
    protected $UserInfo;

    /** @var  User */
    protected $user;

    protected $model;

    private $access;
    
    const ACCESS_USER = 0; 
    const ACCESS_GUEST = 1; 
    const ACCESS_ANYBODY = 2; 

    public function before()
    {
        $isDownload = Cookie::get('fD');
        $this->user = User::instance();
        // Если у нас запрос идет не из AJAX
        if(!$this->request->is_ajax() && !$isDownload)
        {
            // Перенаправляем на ошибку доступа
            throw HTTP_Exception::factory (403, "У Вас нет разрешения скачивать файлы!");
        }
        
        // Обработка POST-данных
        $this->post = Validation::factory(Arr::map('trim', $_POST));
        $this->get = Validation::factory(Arr::map('trim', $_GET));
        
        // Если авторизован, получаем данные аккаунта
        if ($this->user->isSignedIn()) {
            $this->UserInfo = $this->user->toArray();
        }
        
        // Получаем имя маршрута 
        $route = Route::name($this->request->route());
        $route .= ':'.$this->request->controller();
        $userMark = (int)$this->user->RoleMark;
        if ($userMark == 0) {
            $userMark = (int)1;
        }
        // Если запрос не прошел на проверку доступа
        if( !$this->checkAccessLevel() || 
            !$this->checkBitmask($userMark, $route))
        {
            // Перенаправляем на ошибку доступа
            throw HTTP_Exception::factory (403);
        }
    }
    
    protected function setAccessLevel($level)
    {
        $this->access = (int) $level;
    }
    
    protected function checkBitmask($userMark, $route)
    {
        $sysModel = new Model_System;
        $bitmask = (int)$sysModel->getBitmaskForRoute($route);
        if(!$bitmask)
            return true;
        return ($bitmask & $userMark) != 0;
    }    
    
    protected function checkAccessLevel()
    {
        switch($this->access)
        {
            case self::ACCESS_USER:
                return User::instance()->isSignedIn();            
            break;
        
            case self::ACCESS_GUEST:
                return !User::instance()->isSignedIn();            
            break;
        
            case self::ACCESS_ANYBODY:
                return TRUE;
            break;
        }
    }
}
